; ********************************************************************************************
; Alle Macro Definitionen:
; ********************************************************************************************



; ++++ Store to SRAM Location @0 Immediate Value @1
        .MACRO STSI
        push	R16
        ldi	R16,@1
        sts	@0,R16
	pop	R16
        .ENDMACRO



; ++++ Show Text String @0
        .MACRO SHOW
        ldi     ZL,low(2*@0)	; Ausgabe-Kommand-String
        ldi     ZH,high(2*@0)
	rcall	LCDSTR		; .. ausfhren
	rcall	OUTLCD		; .. und Ergebnis anzeigen	
        .ENDMACRO



; ++++ Flash Text String @0 for @1*100ms
        .MACRO FLASH
        ldi     ZL,low(2*@0)	; Ausgabe-Kommand-String
        ldi     ZH,high(2*@0)
	rcall	LCDSTR		; .. ausfhren
	rcall	OUTLCD		; .. und Ergebnis anzeigen
	ldi	ZL,@1		; Flash Timer aufsetzen
	sts	FLATIM,ZL	;
        .ENDMACRO



; ++++ Started Sound-String @0 
        .MACRO SOUND
        ldi     ZL,low(2*@0)	; Sound-String
        sts	SOUPNT,ZL
        ldi     ZH,high(2*@0)
        sts	SOUPNT+1,ZH
        .ENDMACRO



; ++++ Increment 2 Digit BCD within Boundaries
        .MACRO I2BCD
        push	R16
        push	XL
        push	XH
        ldi	XL,@0		; Pointer auf BCD-String
        clr	XH
        rcall	BCD2B		; Wandelt 2B BCD @ X,X+1 nach Bin in R16
        ldi	XL,@1		; Lower Limit
        ldi	XH,@2		; Upper Limit
        rcall	INCLIM		; Increment R16 within limits in XH,XL
        ldi	XL,@0		; Pointer auf BCD-String
        clr	XH
        rcall	B2BCD		; Wandelt Bin in R16 in 2B BCD @ X, X+1
	pop	XH
	pop	XL
	pop	R16
        .ENDMACRO



; ++++ Decrement 2 Digit BCD within Boundaries
        .MACRO D2BCD
        push	R16
        push	XL
        push	XH
        ldi	XL,@0		; Pointer auf BCD-String
        clr	XH
        rcall	BCD2B		; Wandelt 2B BCD @ X,X+1 nach Bin in R16
        ldi	XL,@1		; Lower Limit
        ldi	XH,@2		; Upper Limit
        rcall	DECLIM		; Decrement R16 within limits in XH,XL
        ldi	XL,@0		; Pointer auf BCD-String
        clr	XH
        rcall	B2BCD		; Wandelt Bin in R16 in 2B BCD @ X, X+1
	pop	XH
	pop	XL
	pop	R16
        .ENDMACRO



; ++++ Increment Timer @0 up to @1 ; If @1 reached: @0 = 0 else: goto @2
        .MACRO INCTIM
        lds     R24,@0		; Timer holen
	inc	R24		; und inkrementieren
	sts	@0,R24
	cpi	R24,@1		; Wenn Endwert erreicht
	brne	@2
	clr	R24		; auf 0 setzen
	sts	@0,R24
        .ENDMACRO



	.MACRO SDA_HI
	CBI	DDRC,5
	RCALL	I2WAIT
	.ENDMACRO



	.MACRO SDA_LO
	SBI	DDRC,5
	RCALL	I2WAIT
	.ENDMACRO



	.MACRO SCL_HI
	CBI	DDRC,4
	RCALL	I2WAIT
	.ENDMACRO



	.MACRO SCL_LO
	SBI	DDRC,4
	RCALL	I2WAIT
	.ENDMACRO
